//+------------------------------------------------------------------+
//|                                            DueMedieCheAprono.mq5 |
//|                                                  Giovane Societ |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Giovane Societ"
#property link      ""
#property version   "1.00"

#include <DueMedieCheAprono.mqh> //**** used wrong include type

input int StopLoss = 90;
input int TakeProfit = 30;
input int Ma_Slow_Period = 26;
input int Ma_Fast_Period = 7;
input int MagicNumber = 010110101;
input double Lotti = 1.0;

int STP,TKP;

DueMedieCheAprono Cexpert;

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+


//nell'inizializzazione dell'ea carico (finalmente) le variabili dentro le funzioni create nella classe principale
int OnInit()
  {
   Bars(_Symbol,_Period); //acquisisco le barre con cui dovr lavorare l'ea
   Cexpert.DoInit(Ma_Slow_Period , Ma_Fast_Period);
   Cexpert.SetPeriod(_Period);    
   Cexpert.Setsymbol(_Symbol);   
   Cexpert.SetMagic(MagicNumber);    
   Cexpert.SetLotti(Lotti);          
   STP = StopLoss;
   TKP = TakeProfit;
   if(_Digits==5)
     {
      STP = STP*10;
      TKP = TKP*10;
     }

   return(0);
   }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+

void OnDeinit(const int reason)
  {
   Cexpert.DoUninit();
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   MqlTick latest_price;      
   MqlRates mrate[];        

   ArraySetAsSeries(mrate,true);  //apprendo l'ultimo prezzo e registro tutti i dettagli dentro mrate
   
   SymbolInfoTick(_Symbol,latest_price);
   CopyRates(_Symbol,_Period,0,3,mrate);
   
   //controllo che non ho ordini a mercato su una solita barra
   
   static datetime Prev_time;
   datetime Bar_time[1];
   Bar_time[0]=mrate[0].time;
   if(Prev_time==Bar_time[0])
     {
      return;
     }
   Prev_time=Bar_time[0];

   bool Buy_opened=false,Sell_opened=false; 

   if(PositionSelect(_Symbol)==true) 
     {
      if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
        {
         Buy_opened=true; 
        }
      else if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
        {
         Sell_opened=true;
        }
     }
   // copio il prezzo di chiusura sull'ultima barra (barra[1])
   
   Cexpert.SetClosePrice(mrate[1].close);
   
   //infine controllo se le funzioni per le condizioni di mercato ci sono e mi comporto di conseguenza
   
   if(Cexpert.VerificaLong()==true)
     {
      if(Buy_opened)
        {
         Alert("posizione long gia aperta!!!");
         return;    // Don't open a new Buy Position
        }
      double aprice = NormalizeDouble(latest_price.ask,_Digits);              // current Ask price
      double stl    = NormalizeDouble(latest_price.ask - STP*_Point,_Digits); // Stop Loss
      double tkp    = NormalizeDouble(latest_price.ask + TKP*_Point,_Digits); // Take profit
      int    mdev   = 100;                                                    // Maximum deviation
     
      Cexpert.ApriLong(ORDER_TYPE_BUY,aprice,stl,tkp,mdev);
     }
   if(Cexpert.VerificaShort()==true)
     {

      if(Sell_opened)
        {
         Alert("posizione short gia aperta!!!");
         return;  
        }
      double bprice=NormalizeDouble(latest_price.bid,_Digits);                 // Current Bid price
      double bstl    = NormalizeDouble(latest_price.bid + STP*_Point,_Digits); // Stop Loss
      double btkp    = NormalizeDouble(latest_price.bid - TKP*_Point,_Digits); // Take Profit
      int    bdev=100;                                                         // Maximum deviation
      
      Cexpert.ApriShort(ORDER_TYPE_SELL,bprice,bstl,btkp,bdev);
     }

   return;
  }
//+------------------------------------------------------------------+
   
   